# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with gcj_support
%bcond_without repolib

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define section free
%define parent myfaces

Name:           myfaces-core11-api
Version:        1.1.5
Release:        4%{?dist}
Epoch:          0
Summary:        JSF 1.1 API
License:        ASL 2.0
URL:            http://myfaces.apache.org/
Group:          Development/Libraries/Application Frameworks
# svn export http://svn.apache.org/repos/asf/myfaces/core/tags/1_1_5/ myfaces-core-1.1.5
Source0:        myfaces-core-1.1.5.tar.gz
Source1:        myfaces-core11-api-jpp-depmap.xml
Source2:        myfaces-core11-api-settings.xml

Patch0:         myfaces-core11-UIComponentBaseTest.patch
Patch1:         myfaces-core11-DateTimeConverterTest.patch
Patch2:         myfaces-core11-api-parent-pom.patch
Patch3:         myfaces-core11-api-pom.patch

Provides:  jsf_1_1_api

Requires(post):   jpackage-utils
Requires(postun): jpackage-utils
Requires(post):  %{_sbindir}/update-alternatives
Requires(preun):  %{_sbindir}/update-alternatives

Requires:  java >= 0:1.5.0
Requires:  jakarta-taglibs-standard
Requires:  jpackage-utils
%if 0
# XXX: Doing this will pull in maven plugins, etc.
Requires:       myfaces-maven-master-pom >= 0:1.0.5
%endif
BuildRequires:  myfaces-maven-master-pom >= 0:1.0.5
BuildRequires:  myfaces-maven-build-tools >= 0:1.0.5

BuildRequires:  jpackage-utils
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-doxia
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-surefire-provider-junit

BuildRequires:  easymock-classextension
BuildRequires:  jakarta-taglibs-standard
BuildRequires:  shale-test

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JavaServer(tm) Faces is a new and upcoming web application framework 
that accomplishes the MVC paradigm. It is comparable to the 
well-known Struts Framework but has features and concepts that 
are beyond those of Struts; especially the component orientation. 
Look at Sun's JavaServer(tm) Page to learn more about the Java 
Specification Request 127  and to download the specification. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n myfaces-core-%{version}

%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1
%patch2 -p0 -b .sav2
%patch3 -p0 -b .sav3

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file:`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file:`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file:`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:%{_datadir}/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:%{_datadir}/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -DaltDeploymentRepository=oss-releases::default::file:$(pwd)/maven2-brew \
        deploy javadoc:aggregate

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{parent}
install -p -m 644 api/target/myfaces-api-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{parent}/core11-api-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{parent} && for jar in *-%{version}.jar; do ln -s ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
# don't: this symlink will be brought in by myfaces-core11-impl which  will provide legacy myfaces
#ln -s core11-api.jar $RPM_BUILD_ROOT%{_javadir}/%{parent}/myfaces-jsf-api.jar
touch $RPM_BUILD_ROOT%{_javadir}/jsf_1_1_api.jar

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -p -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-core11.pom
%add_to_maven_depmap org.apache.myfaces.core myfaces-core-project %{version} JPP/%{parent} core11
# FIXME: gId change to agree with JBPAPP_5_1 c-m/pom.xml
%add_to_maven_depmap apache-myfaces myfaces-core-project %{version} JPP/%{parent} core11
install -p -m 644 api/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-core11-api.pom
%add_to_maven_depmap org.apache.myfaces.core myfaces-api %{version} JPP/%{parent} core11-api
# FIXME: gId change to agree with JBPAPP_5_1 c-m/pom.xml
%add_to_maven_depmap apache-myfaces myfaces-api %{version} JPP/%{parent} core11-api

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %with repolib
# repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%{_sbindir}/update-alternatives --install %{_javadir}/jsf_1_1_api.jar jsf_1_1_api \
    %{_javadir}/%{parent}/core11-api.jar 10100

%preun
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove jsf_1_1_api \
        %{_javadir}/%{parent}/core11-api.jar
fi

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc assembly/src/main/resources/LICENSE.txt
%ghost %{_javadir}*/jsf_1_1_api.jar
%dir %{_javadir}*/%{parent}
%{_javadir}*/%{parent}/core11-api-%{version}.jar
%{_javadir}*/%{parent}/core11-api.jar
%{_datadir}/maven2/poms/JPP.%{parent}-core11-api.pom
%{_datadir}/maven2/poms/JPP.%{parent}-core11.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*/
%exclude %dir %{_javadocdir}/
%exclude %dir %{_javadir}*/%{parent}/
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri Mar 25 2011 David Walluck <dwalluck@redhat.com> 0:1.1.5-4
- remove bundled master pom
- fix update-alternatives calls and Requires
- fix javadoc Requires

* Fri Oct 15 2010 Ralph Apel <r.apel@r-apel.de> - 0:1.1.5-3
- Adapt to JPP6

* Wed May 20 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.1.5-2.jpp5
- Fix Release tag

* Wed Mar 11 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.1.5-1.jpp5
- 1.1.5 as myfaces-core11-api

* Mon Mar 13 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.1.0-3jpp
- New name for dependency: easymock-classextension

* Mon Jan 02 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.1.0-2jpp
- Rebuild into JPP 1.7
- Add missing requires for jsp

* Tue Oct 18 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.1.0-1jpp
- First JPackage build
